#ifndef IF_STANDBY_H
#define IF_STANDBY_H

#include "esp_system.h"
#include "freertos/FreeRTOS.h"
#include "freertos/queue.h"
#include "freertos/task.h"
#include "lvgl.h"

#define IF_STANDBY_PAYLOAD_LENGTH 16

typedef enum {
    IF_STANDBY_COMPONENT_BAT,
    IF_STANDBY_COMPONENT_DATE,
    IF_STANDBY_COMPONENT_HUMID,
    IF_STANDBY_COMPONENT_HUMID_ICON,
    IF_STANDBY_COMPONENT_TIME,
    IF_STANDBY_COMPONENT_TEMP,
    IF_STANDBY_COMPONENT_TEMP_ICON,
    IF_STANDBY_COMPONENT_WEEKDAY,
    IF_STANDBY_COMPONENT_WIFI,
} if_standby_component_t;

extern lv_obj_t *g_standby_screen;

esp_err_t if_standby_init(void);
esp_err_t if_standby_component_update(if_standby_component_t component, const char *fmt, ...);

#endif
